
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>分布式文件系统之MogileFS工作原理及实现过程 / 憋错料</title>

    <meta name="description" content="分布式文件系统之MogileFS工作原理及实现过程 MogileFS是一套高效的文件自动备份组件,由Six Apart开发,广泛应用在包括LiveJournal等web2.0站点上.MogileFS由3个部分组成:   第1个部分:是server端,包括mogilefsd和mogstored两个程序.前者即是mogilefsd的tracker,它将一些全局信息保存在数据库里,例如站点domain,class,host等.后者即是存储节点(store node),它其实是个HTTP Daemon,默认侦听在7500端口,接受客户端的文件备份请求.在">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">分布式文件系统之MogileFS工作原理及实现过程</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>MogileFS</strong>是一套高效的文件自动备份组件，由Six Apart开发，广泛应用在包括LiveJournal等web2.0站点上。<br /><strong>MogileFS由3个部分组成</strong>：<br /><strong>&nbsp; &nbsp;第1个部分</strong>：是server端，包括mogilefsd和mogstored两个程序。前者即是mogilefsd的tracker，它将一些全局信息保存在数据库里，例如站点domain,class,host等。后者即是存储节点(store node)，它其实是个HTTP Daemon，默认侦听在7500端口，接受客户端的文件备份请求。在安装完后，要运行mogadm工具将所有的store node注册到mogilefsd的数据库里，mogilefsd会对这些节点进行管理和监控。<br /><strong>&nbsp; &nbsp;第2个部分</strong>：是utils（工具集），主要是MogileFS的一些管理工具，例如mogadm等。<br /><strong>&nbsp; &nbsp;第3个部分</strong>：是客户端API，目前只有Perl API(MogileFS.pm)、PHP，用这个模块可以编写客户端程序，实现文件的备份管理功能,提供MogileFS.pm。</p>
<p>当下互联网飞速发展，海量并发所产生的数据量以几何方式增长，随着信息链接方式日益多样化，数据存储的结构也发生了变化，在这样的压力下我们不得不重新审视大量数据的存储所带来了巨大的挑战：<br /><strong>&nbsp; &nbsp;1、数据采集</strong>：对于社交网站一般都是由用户上传的；<br /><strong>&nbsp; &nbsp;2、数据存储</strong>：现在是数据量大爆炸时代，每天都会产生大量的数据，所以数据存储就成了一个大问题；<br /><strong>&nbsp; &nbsp;3、数据搜索</strong>：如果说存储是考验数据的存储能力的话，那搜索就是考量计算机能力了，从大量的数据中搜索出来；<br /><strong>&nbsp; &nbsp;4、数据共享</strong>：数据存储下来之后还要进行数据的共享问题，大量的数据该怎么共享这些数据呢；<br /><strong>&nbsp; &nbsp;5、数据传输</strong>：而海量数据存储下来之后数据怎么用户与用户之间进行安全的传输；<br /><strong>&nbsp; &nbsp;6、数据分析</strong>：数据的分析是了解我们过去的一些行为规范；<br /><strong>&nbsp; &nbsp;7、数据可视化</strong>：而海量数据存储下来之后怎么样可以直观的展示在人们面前呢；</p>
<p>分布式文件系统的几个难点：<br />&nbsp; &nbsp;1、缺乏全局时钟、不过同步本身就存在时间差，很难做到步调一致，<br />&nbsp; &nbsp;2、面对故障的独立性，分布式是由多个节点组成的，而每个节点都是独立工作的，一个节占故障度不会影响其它节点正常工作，<br />&nbsp; &nbsp;3、如何去处理单点故障， 一是：做冗余，对单点做备份；二是：降低单点故障的影响范围<br />&nbsp; &nbsp;4、事务类的挑战，在分布环境中怎么处理事务呢；ACID或2PI(两段式提交)、最终一致、BASE法则、CAP理论、Paxos算法；</p>
<p><strong>什么是两段式提交</strong>：&nbsp;<br />&nbsp; &nbsp;通过使用某种协议进行通信来完成分布式事务，被称为两段式提交。从名字上看，您可能已经知道有两个阶段：<br /><strong>第一个阶段</strong>，即预提交：<br />&nbsp; &nbsp;事务协调器给每个事务管理器发送准备操作的信号。<br />&nbsp; &nbsp;事务管理器将操作（通常是数据更新）步骤（或细节）写入事务日志。如果失败，事务管理器使用这些步骤重复操作。<br />&nbsp; &nbsp;事务管理器本地创建事务并通知资源管理器对资源（例如，数据库或消息服务器）执行操作。<br />&nbsp; &nbsp;资源管理器执行操作并向事务管理器报告成功（准备提交信号）或失败（准备回滚）。<br />&nbsp; &nbsp;资源管理器等待事务管理器进一步的指令。<br />&nbsp; &nbsp;事务管理器向事务协调器报告成功或失败。<br /><strong>第二阶段</strong>，即提交阶段：在第二阶段中，第一阶段的结果将传送给所有事务管理器。</p>
<p>如果任何事务管理器报告失败，所有的事务参与者都必须回滚。<br />&nbsp; &nbsp;事务协调器让所有事务管理器提交（或回滚）。<br />&nbsp; &nbsp;所有事务管理器将提交或回滚信息传递给其资源管理器。<br />&nbsp; &nbsp;资源管理器将成功或失败提示返回给事务管理器。<br />&nbsp; &nbsp;事务管理器向事务协调器报告成功或失败。</p>
<p><a href="http://s3.51cto.com/wyfs02/M01/26/E9/wKioL1Nt9w3z0lehAAE87dhGcdg736.jpg" rel="external nofollow noreferrer"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvMjYvRTkvd0tpb0wxTnQ5dzN6MGxlaEFBRTg3ZGhHY2RnNzM2LmpwZw==.jpg" /></a></p>
<p><strong>&nbsp;</strong></p>
<p><strong>CAP理论</strong>：一致性，可用性，分区容错性；指一个分布式系统不可以满足一致性，可用性和分区容错性这三个需求，最多只能同时满足其中的两个；<br /><strong>&nbsp; &nbsp;C(Consistency)：一致性</strong>，任何一个读操作总是能够读取之前完成的写操作；就是一个数据写入一立马被读到；<br /><strong>&nbsp; &nbsp;A(Availability)：可用性</strong>，每一次操作总是能够 在确定的时间返回；无论成功或失败都能收到一个返回值的；<br /><strong>&nbsp; &nbsp;P(Tolerance of network Partition)：分区容错性</strong>，在出现网络分区的情况下，仍然能够满足一致性和可用性；</p>
<p><strong>BASE法则</strong>模型反ACID模型，完全不同ACID模型，牺牲高一致性，获得可用性或可靠性：<br /><strong>&nbsp; &nbsp;BA</strong>：Basically Available，基本可以用，支持分区失败(sharding碎片划分数据库)；<br /><strong>&nbsp; &nbsp;S</strong>：Soft state，软状态，接受一段时间内的状态不同步，异步；<br /><strong>&nbsp; &nbsp;E</strong>：Eventually consistent：最终一致性，弱一致性的表现；<br />&nbsp; &nbsp;BASE思想主要强调基本的可用性，如果你需要High 可用性，也就是纯粹的高性能，那么就要以一致性或容错性为牺牲，BASE思想的方案在性能上还是有潜力可挖的。</p>
<p><strong>Paxos算法</strong>：比2PC提交更轻量级的分布式事务的协调方式；大概是指不出现故拜占庭将军的前提下，要取得数据的一致性，在通信信道不安全的时候，我们数据传输可能会被人劫持，这样就不能保证数据的可信了，所以必须保证通信信道安全下Paxos算法才可行；</p>
<p><strong>&nbsp; &nbsp;实现MogileFS的分布式过程</strong>，按照下图构建MogileFS分布式文件系统的结构，这里限于机器的原因，一些服务都整合在一起；</p>
<p><a href="http://s3.51cto.com/wyfs02/M01/26/E9/wKioL1Nt-S7D9i2EAAK4TxGeCvM319.jpg" rel="external nofollow noreferrer"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvMjYvRTkvd0tpb0wxTnQtUzdEOWkyRUFBSzRUeEdlQ3ZNMzE5LmpwZw==.jpg" /></a></p>
<p><strong>&nbsp; &nbsp;第一步：</strong>安装MogileFS软件，我们前面提到，它是由三部分组成，所以三个组件都得安装上，并且每个节点都做MogileFS和Mogstored；</p>
<p>在这里先说一个笔者的基本布局，node0(172.16.27.88)上安装nginx和MariaDB，node1(172.16.27.1)和node2(172.16.27.2)上分别安装了MogileFS和Mogstored，node1和node2都共同使用node0上的MariaDB数据库，nginx做为前端接收用户请求并负载均衡到后端两个节点上；</p>
<p>在node1上的安装和配置过程，修改好配置文件之后复制一份相同的配置文件到node2节点上，因为它们的配置参数都是一样的：</p>
<table>
<tbody>
<tr>
<td>
<br />[[email&#160;protected] ~]# rpm -ivh perl-MogileFS-Client-1.14-1.el6.noarch.rpm perl-Net-Netmask-1.9015-8.el6.noarch.rpm perl-Perlbal-1.78-1.el6.noarch.rpm</p>
<p>[[email&#160;protected] ~]# yum -y install MogileFS-Server-mogstored-2.46-2.el6.noarch.rpm MogileFS-Utils-2.19-1.el6.noarch.rpm MogileFS-Server-2.46-2.el6.noarch.rpm MogileFS-Server-mogilefsd-2.46-2.el6.noarch.rpm perl-IO-AIO</p>
<p># 安装好之后修改配置文件，只需要修改以下几项就可以了</p>
<p>#&nbsp;mysql指使用的数据库是什么，MariaDB也是写mysql；mogdb指数据库名；host=172.16.27.88指定安装数据的地址</p>
<p>[[email&#160;protected] ~]# vim /etc/mogilefs/mogilefsd.conf</p>
<p>db_dsn = DBI:mysql:mogdb:host=172.16.27.1<br />db_user = moguser &nbsp;# 指登录mogdb数据所使用的用户名</p>
<p>db_pass = linux &nbsp; &nbsp;#&nbsp;登录mogdb数据所使用密码</p>
<p>listen = 0.0.0.0:7001 &nbsp;# 0.0.0.0表示监听所有地址</p>
<p># 再编辑mogstored.conf这个配置文件</p>
<p>maxconns = 10000<br />httplisten = 0.0.0.0:7500<br />mgmtlisten = 0.0.0.0:7501<br />docroot = /dfs/mogdata &nbsp;&nbsp;# 把这项改一个特定的目录，以便存储数据，最好是一个独立分区</p>
<p>[[email&#160;protected] ~]# mkdir -pv /dfs/mogdata/dev1&nbsp;&nbsp;# 创建修改的docroot目录</p>
<p>[[email&#160;protected] ~]# chown -R mogilefs.mogilefs /dfs/mogdata/dev1&nbsp;# 修改属主属组</p>
<p>[[email&#160;protected] ~]# chown -R mogilefs.mogilefs&nbsp;/var/run/mogilefsd/</p>
<p>[[email&#160;protected] ~]# cd /etc/mogilefs</p>
<p>[[email&#160;protected] ~]# scp mogilefsd.conf mogstored.conf [email&#160;protected]:/etc/mogilefs/&nbsp;&nbsp;# 复制修改好的配置文件到node2的mogilefs目录下，覆盖即可，两个节点都安装配置好之后先不要启动服务，数据库还没有安装</p>
</td>
</tr>
</tbody>
</table>
<p>在node2上的安装和配置，<strong>这里的配置文件由node1上复制过来就可以了</strong>；</p>
<table>
<tbody>
<tr>
<td>
<br />[[email&#160;protected] ~]# rpm -ivh perl-MogileFS-Client-1.14-1.el6.noarch.rpm perl-Net-Netmask-1.9015-8.el6.noarch.rpm perl-Perlbal-1.78-1.el6.noarch.rpm</p>
<p>[[email&#160;protected] ~]# yum -y install MogileFS-Server-mogstored-2.46-2.el6.noarch.rpm MogileFS-Utils-2.19-1.el6.noarch.rpm MogileFS-Server-2.46-2.el6.noarch.rpm MogileFS-Server-mogilefsd-2.46-2.el6.noarch.rpm perl-IO-AIO</p>
<p>[[email&#160;protected] ~]# mkdir -pv /dfs/mogdata/dev2&nbsp;&nbsp;# 创建修改的docroot目录</p>
<p>[[email&#160;protected] ~]# chown -R mogilefs.mogilefs&nbsp;/var/run/mogilefsd/</p>
<p>[[email&#160;protected] ~]# chown -R mogilefs.mogilefs /dfs/mogdata/dev2&nbsp;# 修改属主属组</p>
</td>
</tr>
</tbody>
</table>
<p><strong>第二步：</strong>安装nginx和MariaDB，这里安装Nginx需要编译安装，因为他需要装载第三方模块才可以使用mogilefs，MariaDB安装这里就不再说明了；</p>
<p>在<strong>node0</strong>节点上的安装步骤：</p>
<table>
<tbody>
<tr>
<td>
<br /># 解决依赖关系</p>
<p>[[email&#160;protected] ~]# yum -y groupinstall "Development Tools" "Server Platform Development"</p>
<p>[[email&#160;protected] ~]# yum -y install openssl-devel pcre-devel</p>
<p>[[email&#160;protected] ~]# groupadd -r nginx<br />[[email&#160;protected] ~]# useradd -r -g nginx nginx<br />[[email&#160;protected] ~]# tar xf nginx-1.4.2.tar.gz</p>
<p>[[email&#160;protected] ~]# unzip&nbsp;nginx-mogilefs-module-master.zip</p>
<p>[[email&#160;protected] ~]# cd nginx-1.4.2<br />[[email&#160;protected] nginx-1.4.2]# ls&nbsp;<br />auto&nbsp;&nbsp;CHANGES &nbsp;CHANGES.ru &nbsp;conf&nbsp;configure&nbsp;contrib &nbsp;html&nbsp;&nbsp;LICENSE &nbsp;man&nbsp;&nbsp;README &nbsp;src<br />[[email&#160;protected] nginx-1.4.2]# ./configure \<br />&gt; &nbsp; --prefix=/usr \<br />&gt; &nbsp; --sbin-path=/usr/sbin/nginx \<br />&gt; &nbsp; --conf-path=/etc/nginx/nginx.conf \<br />&gt; &nbsp; --error-log-path=/var/log/nginx/error.log \<br />&gt; &nbsp; --http-log-path=/var/log/nginx/access.log \<br />&gt; &nbsp; --pid-path=/var/run/nginx/nginx.pid &nbsp;\<br />&gt; &nbsp; --lock-path=/var/lock/nginx.lock \<br />&gt; &nbsp; --user=nginx \<br />&gt; &nbsp; --group=nginx \<br />&gt; &nbsp; --with-http_ssl_module \<br />&gt; &nbsp; --with-http_flv_module \<br />&gt; &nbsp; --with-http_stub_status_module \<br />&gt; &nbsp; --with-http_gzip_static_module \<br />&gt; &nbsp; --http-client-body-temp-path=/var/tmp/nginx/client/ \<br />&gt; &nbsp; --http-proxy-temp-path=/var/tmp/nginx/proxy/ \<br />&gt; &nbsp; --http-fastcgi-temp-path=/var/tmp/nginx/fcgi/ \<br />&gt; &nbsp; --http-uwsgi-temp-path=/var/tmp/nginx/uwsgi \<br />&gt; &nbsp; --http-scgi-temp-path=/var/tmp/nginx/scgi \<br />&gt; &nbsp; --with-pcre \<br />&gt; &nbsp; --with-debug \<br />&gt; &nbsp; --add-module=/root/nginx-mogilefs-module-master &nbsp;# 这里要指定编译的模块</p>
<p>[[email&#160;protected] nginx-1.4.2]# make &amp;&amp; make install</p>
<p># 这里MariaDB安装过程不再说明了，可以参数前面的博文，编译安装好之后就可以可以启动MariaDB和去配置Nginx的相关配置了，还要给nginx提供一个服务脚本；</p>
<p>[[email&#160;protected] support-files]# service mysqld start<br />Starting MySQL... &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;[ &nbsp;OK&nbsp;&nbsp;]</p>
<p>[[email&#160;protected] nginx-1.4.2]# vim /etc/rc.d/init.d/nginx</p>
<p>#!/bin/sh<br />#<br /># nginx - this script starts and stops the nginx daemon<br />#<br /># chkconfig: &nbsp; - 85 15&nbsp;<br /># description: &nbsp;Nginx is an HTTP(S) server, HTTP(S) reverse \<br /># &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; proxy and IMAP/POP3 proxy server<br /># processname: nginx<br /># config: &nbsp; &nbsp; &nbsp;/etc/nginx/nginx.conf<br /># config: &nbsp; &nbsp; &nbsp;/etc/sysconfig/nginx<br /># pidfile: &nbsp; &nbsp; /var/run/nginx.pid</p>
<p># Source function library.<br />. /etc/rc.d/init.d/functions</p>
<p># Source networking configuration.<br />. /etc/sysconfig/network</p>
<p># Check that networking is up.<br />[ "$NETWORKING" = "no" ] &amp;&amp; exit 0</p>
<p>nginx="/usr/sbin/nginx"<br />prog=$(basename $nginx)</p>
<p>NGINX_CONF_FILE="/etc/nginx/nginx.conf"</p>
<p>[ -f /etc/sysconfig/nginx ] &amp;&amp; . /etc/sysconfig/nginx</p>
<p>lockfile=/var/lock/subsys/nginx</p>
<p>make_dirs() {<br />&nbsp; # make required directories<br />&nbsp; user=`nginx -V 2&gt;&amp;1 | grep "configure arguments:" | sed ‘s/[^*]*--user=\([^ ]*\).*/\1/g‘ -`<br />&nbsp; options=`$nginx -V 2&gt;&amp;1 | grep ‘configure arguments:‘`<br />&nbsp; for opt in $options; do<br />&nbsp; &nbsp; &nbsp; if [ `echo $opt | grep ‘.*-temp-path‘` ]; then<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; value=`echo $opt | cut -d "=" -f 2`<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; if [ ! -d "$value" ]; then<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; # echo "creating" $value<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; mkdir -p $value &amp;&amp; chown -R $user $value<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; fi<br />&nbsp; &nbsp; &nbsp; fi<br />&nbsp; done<br />}</p>
<p>start() {<br />&nbsp; &nbsp;[ -x $nginx ] || exit 5<br />&nbsp; &nbsp;[ -f $NGINX_CONF_FILE ] || exit 6<br />&nbsp; &nbsp;make_dirs<br />&nbsp; &nbsp;echo -n $"Starting $prog: "<br />&nbsp; &nbsp;daemon $nginx -c $NGINX_CONF_FILE<br />&nbsp; &nbsp;retval=$?<br />&nbsp; &nbsp;echo<br />&nbsp; &nbsp;[ $retval -eq 0 ] &amp;&amp; touch $lockfile<br />&nbsp; &nbsp;return $retval<br />}</p>
<p>stop() {<br />&nbsp; &nbsp;echo -n $"Stopping $prog: "<br />&nbsp; &nbsp;killproc $prog -QUIT<br />&nbsp; &nbsp;retval=$?<br />&nbsp; &nbsp;echo<br />&nbsp; &nbsp;[ $retval -eq 0 ] &amp;&amp; rm -f $lockfile<br />&nbsp; &nbsp;return $retval<br />}</p>
<p>restart() {<br />&nbsp; &nbsp;configtest || return $?<br />&nbsp; &nbsp;stop<br />&nbsp; &nbsp;sleep 1<br />&nbsp; &nbsp;start<br />}</p>
<p>reload() {<br />&nbsp; &nbsp;configtest || return $?<br />&nbsp; &nbsp;echo -n $"Reloading $prog: "<br />&nbsp; &nbsp;killproc $nginx -HUP<br />&nbsp; &nbsp;RETVAL=$?<br />&nbsp; &nbsp;echo<br />}</p>
<p>force_reload() {<br />&nbsp; &nbsp;restart<br />}</p>
<p>configtest() {<br />&nbsp;$nginx -t -c $NGINX_CONF_FILE<br />}</p>
<p>rh_status() {<br />&nbsp; &nbsp;status $prog<br />}</p>
<p>rh_status_q() {<br />&nbsp; &nbsp;rh_status &gt;/dev/null 2&gt;&amp;1<br />}</p>
<p>case "$1" in<br />&nbsp; &nbsp;start)<br />&nbsp; &nbsp; &nbsp; &nbsp;rh_status_q &amp;&amp; exit 0<br />&nbsp; &nbsp; &nbsp; &nbsp;$1<br />&nbsp; &nbsp; &nbsp; &nbsp;;;<br />&nbsp; &nbsp;stop)<br />&nbsp; &nbsp; &nbsp; &nbsp;rh_status_q || exit 0<br />&nbsp; &nbsp; &nbsp; &nbsp;$1<br />&nbsp; &nbsp; &nbsp; &nbsp;;;<br />&nbsp; &nbsp;restart|configtest)<br />&nbsp; &nbsp; &nbsp; &nbsp;$1<br />&nbsp; &nbsp; &nbsp; &nbsp;;;<br />&nbsp; &nbsp;reload)<br />&nbsp; &nbsp; &nbsp; &nbsp;rh_status_q || exit 7<br />&nbsp; &nbsp; &nbsp; &nbsp;$1<br />&nbsp; &nbsp; &nbsp; &nbsp;;;<br />&nbsp; &nbsp;force-reload)<br />&nbsp; &nbsp; &nbsp; &nbsp;force_reload<br />&nbsp; &nbsp; &nbsp; &nbsp;;;<br />&nbsp; &nbsp;status)<br />&nbsp; &nbsp; &nbsp; &nbsp;rh_status<br />&nbsp; &nbsp; &nbsp; &nbsp;;;<br />&nbsp; &nbsp;condrestart|try-restart)<br />&nbsp; &nbsp; &nbsp; &nbsp;rh_status_q || exit 0<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;;;<br />&nbsp; &nbsp;*)<br />&nbsp; &nbsp; &nbsp; &nbsp;echo $"Usage: $0 {start|stop|status|restart|condrestart|try-restart|reload|force-reload|configtest}"<br />&nbsp; &nbsp; &nbsp; &nbsp;exit 2<br />esac</p>
<p>[[email&#160;protected] nginx-1.4.2]# chmod +x /etc/init.d/nginx</p>
<p>[[email&#160;protected] nginx-1.4.2]# vim /etc/profile.d/nginx.sh</p>
<p>export PATH=/usr/sbin/nginx:$PATH</p>
<p>[[email&#160;protected] nginx-1.4.2]# . /etc/profile.d/nginx.sh</p>
<p>[[email&#160;protected] nginx-1.4.2]# service nginx start<br />Starting nginx: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;[ &nbsp;OK&nbsp;&nbsp;]</p>
<p>[[email&#160;protected] nginx-1.4.2]# ss -tnl<br />State &nbsp; &nbsp; &nbsp;Recv-Q Send-Q &nbsp; &nbsp; &nbsp; &nbsp;Local Address:Port &nbsp; &nbsp; &nbsp; Peer Address:Port&nbsp;<br />LISTEN &nbsp; &nbsp; 0 &nbsp; &nbsp; &nbsp;128 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;:::111 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; :::* &nbsp; &nbsp;&nbsp;<br />LISTEN &nbsp; &nbsp; 0 &nbsp; &nbsp; &nbsp;128 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; *:111 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;*:* &nbsp; &nbsp;&nbsp;<br />LISTEN &nbsp; &nbsp; 0 &nbsp; &nbsp; &nbsp;128 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;*:80&nbsp;&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;*:*</p>
</td>
</tr>
</tbody>
</table>
<p>测试访问一下nginx的页面：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDEvMjYvRUEvd0tpb0wxTnVJYXpod1M0cEFBR3R5Z0RlRVJjNjA2LmpwZw==.jpg" /></p>
<p><strong>第三步：</strong>连接上数据库，给两个用户授权：</p>
<table>
<tbody>
<tr>
<td>[[email&#160;protected] ~]# mysql -uroot -p<br />Enter password:&nbsp;<br /><strong>Welcome to the MariaDB monitor. &nbsp;Commands end with ; or \g.<br />Your MariaDB connection id is 46<br />Server version: 10.0.10-MariaDB-log MariaDB Server</p>
<p>Copyright (c) 2000, 2014, Oracle, SkySQL Ab and others.</p>
<p>Type ‘help;‘ or ‘\h‘ for help. Type ‘\c‘ to clear the current input statement.</strong></p>
<p>MariaDB [(none)]&gt; USE mysql;</p>
<p><strong>Database changed</strong></p>
<p>MariaDB [mysql]&gt; GRANT ALL ON *.* TO ‘root‘@‘172.16.%.%‘ IDENTIFIED BY ‘linux‘;<br /><strong>Query OK, 0 rows affected (0.20 sec)</strong></p>
<p>MariaDB [mysql]&gt; GRANT ALL ON mogdb.* TO ‘moguser‘@‘172.16.%.%‘ IDENTIFIED BY ‘linux‘;<br /><strong>Query OK, 0 rows affected (0.00 sec)</strong></p>
<p>MariaDB [mysql]&gt; FLUSH PRIVILEGES;<br /><strong>Query OK, 0 rows affected (0.21 sec)</strong></p>
<p>MariaDB [mysql]&gt;&nbsp;</td>
</tr>
</tbody>
</table>
<p><strong>第四步：</strong>再到两个节点上，在其中一个上设置即可：</p>
<table>
<tbody>
<tr>
<td>
<br />[[email&#160;protected] mogilefs]# mogdbsetup --dbhost=172.16.27.88 --dbport=3306 --dbname=mogdb --dbrootuser=root --dbrootpass=linux --dbuser=moguser --dbpass=linux --yes</p>
<p># 可以再回到node0上查看一下生成的数据库</p>
<p>MariaDB [mysql]&gt; USE mogdb;<br />Database changed</p>
<p>MariaDB [mogdb]&gt; SHOW TABLES;<br />+----------------------+<br />| Tables_in_mogdb &nbsp; &nbsp; &nbsp;|<br />+----------------------+<br />| checksum &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; |<br />| class &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;|<br />| device &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; |<br />| domain &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; |<br />| file &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; |<br />| file_on &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;|<br />| file_on_corrupt &nbsp; &nbsp; &nbsp;|<br />| file_to_delete &nbsp; &nbsp; &nbsp; |<br />| file_to_delete2 &nbsp; &nbsp; &nbsp;|<br />| file_to_delete_later |<br />| file_to_queue &nbsp; &nbsp; &nbsp; &nbsp;|<br />| file_to_replicate &nbsp; &nbsp;|<br />| fsck_log &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; |<br />| host &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; |<br />| server_settings &nbsp; &nbsp; &nbsp;|<br />| tempfile &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; |<br />| unreachable_fids &nbsp; &nbsp; |<br />+----------------------+<br />17 rows in set (0.03 sec)</p>
</td>
</tr>
</tbody>
</table>
<p><strong>第五步：</strong>在两个节点的其中一个上添加主机：</p>
<table>
<tbody>
<tr>
<td>[[email&#160;protected] ~]# mogadm --trackers=172.16.27.1:7001 host add 172.16.27.1 --ip=172.16.27.1 --status=alive<br />[[email&#160;protected] ~]# mogadm --trackers=172.16.27.1:7001 host add 172.16.27.2 --ip=172.16.27.2 --status=alive<br />[[email&#160;protected] mogilefs]# mogadm --trackers=172.16.27.1:7001 host list<br />172.16.27.1 [1]: alive<br />&nbsp;IP: &nbsp; &nbsp; &nbsp; 172.16.27.1:7500</p>
<p>172.16.27.2 [2]: alive</p>
<p>IP: &nbsp; &nbsp; &nbsp; 172.16.27.2:7500</p>
<p># 再添加设备</p>
<p>[[email&#160;protected] mogilefsd]# mogadm --trackers=172.16.27.1:7001 device add 172.16.27.1 1<br />[[email&#160;protected] mogilefsd]# mogadm --trackers=172.16.27.1:7001 device add 172.16.27.2 2<br />[[email&#160;protected] mogilefsd]# mogadm --trackers=172.16.27.1:7001 device list<br />172.16.27.1 [1]: alive<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;used(G) &nbsp; &nbsp;free(G) &nbsp; total(G) &nbsp;weight(%)<br />&nbsp; dev1: &nbsp; alive &nbsp; &nbsp; &nbsp;2.799 &nbsp; &nbsp; 15.887 &nbsp; &nbsp; 18.686 &nbsp; &nbsp; &nbsp; &nbsp;100</p>
<p>172.16.27.2 [2]: alive<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;used(G) &nbsp; &nbsp;free(G) &nbsp; total(G) &nbsp;weight(%)<br />&nbsp; dev2: &nbsp; alive &nbsp; &nbsp; &nbsp;1.476 &nbsp; &nbsp; 17.210 &nbsp; &nbsp; 18.686 &nbsp; &nbsp; &nbsp; &nbsp;100</p>
<p>#</p>
<p>[[email&#160;protected] ~]# mogadm --trackers=172.16.27.1:7001 domain add images&nbsp;# 添加域<br />[[email&#160;protected] ~]# mogadm --trackers=172.16.27.1:7001 domain add files<br />[[email&#160;protected] ~]# mogadm --trackers=172.16.27.1:7001 domain add html<br />[[email&#160;protected] ~]# mogadm --trackers=172.16.27.1:7001 domain list &nbsp;# 查看域</p>
<p>domain &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; class &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;mindevcount &nbsp; replpolicy &nbsp; hashtype<br />-------------------- -------------------- ------------- ------------ -------<br />files &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;default &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 2 &nbsp; &nbsp; &nbsp; &nbsp;MultipleHosts() NONE</p>
<p>html &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; default &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 2 &nbsp; &nbsp; &nbsp; &nbsp;MultipleHosts() NONE</p>
<p>images &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; default &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 2 &nbsp; &nbsp; &nbsp; &nbsp;MultipleHosts() NONE</p>
<p>[[email&#160;protected] ~]# mogadm --trackers=172.16.27.1:7001 class add images class0 --mindevcount=2<br />[[email&#160;protected] ~]# mogadm --trackers=172.16.27.1:7001 class list<br />domain &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; class &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;mindevcount &nbsp; replpolicy &nbsp; hashtype<br />-------------------- -------------------- ------------- ------------ -------<br />files &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;default &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 2 &nbsp; &nbsp; &nbsp; &nbsp;MultipleHosts() NONE</p>
<p>html &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; default &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 2 &nbsp; &nbsp; &nbsp; &nbsp;MultipleHosts() NONE</p>
<p>images &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; class0 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;2 &nbsp; &nbsp; &nbsp; &nbsp;MultipleHosts() NONE&nbsp;#添加类<br />images &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; default &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 2 &nbsp; &nbsp; &nbsp; &nbsp;MultipleHosts() NONE &nbsp;&nbsp;<br /># 上传几张图片和测试的页面上去<br />[[email&#160;protected] ~]# mogupload --trackers=172.16.27.1:7001 --domain=images --key=‘1.png‘ --file=‘/usr/share/backgrounds/default_1920x1200.png‘ &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;<br />[[email&#160;protected] ~]# mogupload --trackers=172.16.27.1:7001 --domain=images --key=‘2.png‘ --file=‘/usr/share/backgrounds/wallpaper-six-2560x1240.png‘</p>
<p>[[email&#160;protected] ~]# mogupload --trackers=172.16.27.1:7001 --domain=images --key=‘/images/3.png‘ --file=‘/usr/share/backgrounds/centos_wallpaper_01_1920x1200.png‘</p>
<p>[[email&#160;protected] ~]# mogupload --trackers=172.16.27.1:7001 --domain=html --key=‘/files/index.html‘ --file=‘/var/www/html/index.html‘<br />[[email&#160;protected] ~]# mogupload --trackers=172.16.27.1:7001 --domain=files --key=‘/files/index.html‘ --file=‘/var/www/html/index.html‘</p>
<p>[[email&#160;protected] ~]# moglistkeys --trackers=172.16.27.1:7001 --domain=images<br />/images/3.png<br />1.png<br />2.png<br />[[email&#160;protected] ~]# mogfileinfo --trackers=172.16.27.1:7001 --domain=images --key=‘/images/3.png‘<br />- file: /images/3.png<br />&nbsp; &nbsp; class: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;default<br />&nbsp;devcount: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;2<br />&nbsp; &nbsp;domain: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; images<br />&nbsp; &nbsp; &nbsp; fid: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;5<br />&nbsp; &nbsp; &nbsp; key: &nbsp; &nbsp; &nbsp; &nbsp;/images/3.png<br />&nbsp; &nbsp;length: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 202652<br />- http://172.16.27.2:7500/dev2/0/000/000/0000000005.fid<br />- http://172.16.27.1:7500/dev1/0/000/000/0000000005.fid<br />[[email&#160;protected] ~]# mogfileinfo --trackers=172.16.27.1:7001 --domain=files --key=‘/files/index.html‘<br />- file: /files/index.html<br />&nbsp; &nbsp; class: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;default<br />&nbsp;devcount: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;2<br />&nbsp; &nbsp;domain: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;files<br />&nbsp; &nbsp; &nbsp; fid: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;9<br />&nbsp; &nbsp; &nbsp; key: &nbsp; &nbsp;/files/index.html<br />&nbsp; &nbsp;length: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; 53<br />- http://172.16.27.2:7500/dev2/0/000/000/0000000009.fid<br />- http://172.16.27.1:7500/dev1/0/000/000/0000000009.fid<br />[[email&#160;protected] ~]#</p>
</td>
</tr>
</tbody>
</table>
<p>可以复制这个地址在页面上测试一下，这里是每上传一个文件就都会在两个节点是都存一份，如果节点多的话它会根据定义的devcount自己选择节点存储几份，这样在一个节点掉了也可以在别的节点在有相同的资源可用；</p>
<p><strong>第五步：</strong>以上的都配置好了就可以在前端的Nginx上配置访问控制了，修改配置文件：</p>
<table>
<tbody>
<tr>
<td>
<br />[[email&#160;protected] nginx]# vim nginx.conf</p>
<p>upstream mogcluster { &nbsp; &nbsp;# 定义多个上游服务器<br />&nbsp; &nbsp; &nbsp; &nbsp;server 172.16.27.1:7001;<br />&nbsp; &nbsp; &nbsp; &nbsp;server 172.16.27.2:7001;<br />&nbsp; &nbsp;}<br />&nbsp; &nbsp;server { &nbsp; &nbsp;# 定义一个虚拟主机<br />&nbsp; &nbsp; &nbsp; &nbsp;listen 80;<br />&nbsp; &nbsp; &nbsp; &nbsp;server_name www.tanxw.com;</p>
<p>location /images/ {<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;mogilefs_tracker mogcluster;<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;mogilefs_domain images;</p>
<p>mogilefs_pass {<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;proxy_pass $mogilefs_path;<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;proxy_hide_header Content-Type;<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;proxy_buffering off;<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;}<br />&nbsp; &nbsp; &nbsp; &nbsp;}<br />&nbsp; &nbsp; &nbsp; &nbsp;location ~* ^(/files/.*)$ {<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;mogilefs_tracker mogcluster;<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;mogilefs_domain files;</p>
<p>mogilefs_pass $1 {<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;proxy_pass $mogilefs_path;<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;proxy_hide_header Content-Type;<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;proxy_buffering off;<br />&nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;}<br />&nbsp; &nbsp; &nbsp; &nbsp;}<br />&nbsp; &nbsp;}</p>
<p># 修改好配置文件后保存退出重启服务</p>
<p>[[email&#160;protected] nginx]# service nginx restart<br />nginx: the configuration file /etc/nginx/nginx.conf syntax is ok<br />nginx: configuration file /etc/nginx/nginx.conf test is successful<br />Stopping nginx: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;[ &nbsp;OK&nbsp;&nbsp;]<br />Starting nginx: &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp;[ &nbsp;OK&nbsp;&nbsp;]<br />[[email&#160;protected] nginx]#</p>
</td>
</tr>
</tbody>
</table>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvMjYvRUMvd0tpb20xTnUwa3ZoVW9YN0FBR05selloeWtFNDI2LmpwZw==.jpg" /></p>
<p>然后在页面上测试访问刚才上传的文件以及图片：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDAvMjYvRUMvd0tpb20xTnUwbHZnb244d0FBRjZwb1I5b2prMjA3LmpwZw==.jpg" /></p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvczMuNTFjdG8uY29tL3d5ZnMwMi9NMDIvMjYvRUMvd0tpb0wxTnUwanpEc25mcUFBRHRBMTZ0bFdJNTcxLmpwZw==.jpg" /></p>
<p><strong>总结：</strong></p>
<p>最后还可以测试一下把一个节点掉了，试着访问一下看另外正常工作的节点可不可以正常提供服务，这里还可以添加很多功能的，后续还会更新相关的基础网站服务器架构搭建的文章，在此，如果发现在什么不妥或做得不到的还望大家多提点建议。</p>
<p>本文出自 &ldquo;<a href="http://tanxw.blog.51cto.com/" rel="external nofollow noreferrer">温水煮青蛙</a>&rdquo; 博客，请务必保留此出处<a href="http://tanxw.blog.51cto.com/4309543/1409362" rel="external nofollow noreferrer">http://tanxw.blog.51cto.com/4309543/1409362</a></p>
<p><P>分布式文件系统之MogileFS工作原理及实现过程</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-03 19:41:48 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/des/" title="des">des</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/%e4%bd%bf%e7%94%a8/" title="使用">使用</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/strong/" title="strong">strong</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>分布式文件系统之MogileFS工作原理及实现过程的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a7mmP4.html" rel="bookmark">CentOS 6&period;5 分布式文件系统之MogileFS工作原理及实现过程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				   MogileFS是一套高效的文件自动备份组件,由Six Apart开发,广泛应用在包括LiveJournal等web2.0站点上.MogileFS由3个部分组成:    第1个部分:是server端,包括mogilefsd和mogstored两个程序.前者即是mogilefsd的tracker,它将一些全局信息保存在数据库里,例如站点domain,class,host等.后者即是存储节点(store node),它其实是个HTTP Daemon,默认侦听在7500端口,接受客户端的文件备份			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZewZJ0.html" rel="bookmark">大数据 --&amp;gt&semi; 分布式文件系统HDFS的工作原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				分布式文件系统HDFS的工作原理 Hadoop分布式文件系统(HDFS)是一种被设计成适合运行在通用硬件上的分布式文件系统.HDFS是一个高度容错性的系统,适合部署在廉价的机器上.它能提供高吞吐量的数据访问,非常适合大规模数据集上的应用.要理解HDFS的内部工作原理,首先要理解什么是分布式文件系统. 1.分布式文件系统 多台计算机联网协同工作(有时也称为一个集群)就像单台系统一样解决某种问题,这样的系统我们称之为分布式系统. 分布式文件系统是分布式系统的一个子集,它们解决的问题就是数据存储.换句			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02gQk23.html" rel="bookmark">【转载】Hadoop分布式文件系统HDFS的工作原理详述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明来自36大数据(36dsj.com):36大数据 » Hadoop分布式文件系统HDFS的工作原理详述 转注:读了这篇文章以后,觉得内容比较易懂,所以分享过来支持一下. Hadoop分布式文件系统(HDFS)是一种被设计成适合运行在通用硬件上的分布式文件系统.HDFS是一个高度容错性的系统,适合部署在廉价的 机器上.它能提供高吞吐量的数据访问,非常适合大规模数据集上的应用.要理解HDFS的内部工作原理,首先要理解什么是分布式文件系统. 1.分布式文件系统 多台计算机联网协同工作(有时也			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rQZmq0.html" rel="bookmark">Hadoop分布式文件系统HDFS的工作原理详述</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Hadoop分布式文件系统(HDFS)是一种被设计成适合运行在通用硬件上的分布式文件系统.HDFS是一个高度容错性的系统,适合部署在廉价的机器上.它能提供高吞吐量的数据访问,非常适合大规模数据集上的应用.要理解HDFS的内部工作原理,首先要理解什么是分布式文件系统. 1.分布式文件系统 多台计算机联网协同工作(有时也称为一个集群)就像单台系统一样解决某种问题,这样的系统我们称之为分布式系统. 分布式文件系统是分布式系统的一个子集,它们解决的问题就是数据存储.换句话说,它们是横跨在多台计算机上的存			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLgxgv4.html" rel="bookmark">Hadoop分布式文件系统HDFS的工作原理</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Hadoop分布式文件系统(HDFS)是一种被设计成适合运行在通用硬件上的分布式文件系统.HDFS是一个高度容错性的系统,适合部署在廉价的机器上.它能提供高吞吐量的数据访问,非常适合大规模数据集上的应用.要理解HDFS的内部工作原理,首先要理解什么是分布式文件系统. 1 .分布式文件系统 多台计算机联网协同工作(有时也称为一个集群)就像单台系统一样解决某种问题,这样的系统我们称之为分布式系统. 分布式文件系统是分布式系统的一个子集,它们解决的问题就是数据存储. 换句话说,它们是横跨在多台计算机上			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLqP1d0.html" rel="bookmark">分布式文件系统之MogileFS实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.简介    1.分布式文件系统 分布式文件系统(Distributed File System)是指文件系统管理的物理存储资源不一定直接连接在本地节点上,而是通过计算机网络与节点相连,也就是集群文件系统,可以支持大数量的节点以及PB级的数量存储. 相对地,在一个分享的磁盘文件系统中,所有节点对数据存储区块都有相同的访问权,在这样的系统中,访问权限就必须由客户端程序来控制. 分布式文件系统可能包含的功能有:透通的数据复制与容错.也就是说,即使系统中有一小部份的节点脱机,整体来说系统仍然可以持续			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eaNGJ0.html" rel="bookmark">分布式文件系统之MogileFS的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.mogilefs简介 MogileFS 是一个开源的分布式文件系统,用于组建分布式文件集群,由 LiveJournal 旗下 Danga Interactive 公司开发,Danga 团队开发了包括 Memcached.MogileFS.Perlbal 等不错的开源项目:(注:Perlbal 是一个强大的 Perl 写的反向代理服务器). MogileFS由3个部分组成: 第1个部分: 是server端,包括mogilefsd和mogstored两个程序.前者即是mogilefsd的trac			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dgQoeM.html" rel="bookmark">分布式文件系统之&amp;mdash&semi;&amp;mdash&semi;mogilefs</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节我们将来认识下分布式文件系统,不过我主要讲的是关于其中的一个比较流行的mogilefs进行介绍,好了其他的不多说了,下面我们就开始吧. 什么是分布式文件系统? 什么是分布式文件系统(Distributed File System)?顾名思义,就是分布式+文件系统.它包含了2方面,从文件系统的客户端的角度来看,他就是一个标准的文件系统,提供了API,由此可以进行文件的创建.删除.读写等操作:从内部来看的话,分布式文件系统则与普通的文件系统不同,它不在是本地的磁盘中,它的内容和目录都不是存储在本			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPe8N10.html" rel="bookmark">21&period;文件系统&mdash;&mdash;yum的工作原理以及如何建立yum仓库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.yum的工作原理 yum是一个RPM包的前端管理工具,在rpm包的依赖关系已经被建成数据库的前提下,它能够实现自动查找相互依赖的rpm包,并从repository中下载互相依赖的rpm包到本地. 二.如何建立yum的仓库repository 如果yum和repository不在同一台主机上,那么能够为yum提供repository仓库服务的远程服务器协议通常有两类:(1)ftp://(2)http:// 如果yum和repository在同一台主机上,那么yum就可以直接到某个目录中提取rp			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/V0bYwvM.html" rel="bookmark" class="title">想：类在一个包提前声明，然后在另一个包描述具体的类内容，但是有问题</a>
					<div>
						想法源于:类可以提前声明,具体类内容可以后面写明: TFrmChangePWTransparent = class; //这里声明其他的类,或一些表里 TFrmChangePWTransparent  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/P47wER4.html" rel="bookmark" class="title">LeetCode：Integer to Roman</a>
					<div>
						1.题目名称 Integer to Roman (阿拉伯数字到罗马数字的转换) 2.题目地址 https://leetcode.com/problems/integer-to-roman 3.题目内容 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/949EVg4.html" rel="bookmark" class="title">剑指offer---数组中重复的数字</a>
					<div>
						class Solution { public:     // Parameters:     //        numbers:     an array of integers     //   ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/W0jP2A4.html" rel="bookmark" class="title">52-which  简明笔记</a>
					<div>
						显示系统命令所在目录 which command-list 参数 command-list 是which搜索的一条或多条命令(实用程序) 示例 which 单条命令 1 $ which ls 2 /b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXdvGGM.html" rel="bookmark" class="title">日常的修修补补</a>
					<div>
						说明:所有日常中遇到的一两句话就能解决的问题,都将记录在这(长期更新) 1.ats日志squid.blog,查看需要traffic_logcat命令,而又想tail -f 实时查看,经测试 tail  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDZBoY3.html" rel="bookmark" class="title">Spring Boot 探索系列 - 自动化配置篇</a>
					<div>
						26. Logging Prev  Part IV. Spring Boot features  Next 26. Logging Spring Boot uses Commons Logging f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vvwn93.html" rel="bookmark" class="title">STL空间配置器那点事</a>
					<div>
						STL简介 STL(Standard Template Library,标准模板库),从根本上说,STL是一些“容器”的集合,这些“容器”有list,vector,set,map等,STL也是算法和其 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0awmAA4.html" rel="bookmark" class="title">初学JAVA&mdash;&mdash;代码练习（冒泡排序）</a>
					<div>
						package XQ; public class BianLiErWeiShuZu { public static void main(String[] args) { int[] A = new i ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLjmpk3.html" rel="bookmark" class="title">SQL - 复制数据库中的一行</a>
					<div>
						insert into MyTable(field1, field2, id_backup) select field1, field2, uniqueId from MyTable where un ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bYzxYM.html" rel="bookmark" class="title">该如何存在</a>
					<div>
						七八年前,一个我认识的重庆女孩因为前一天打牌和shopping用光了现钞,打上车才发觉,以至于只能在路边选择,按照她的说法,一辆不那么新,没有空调,噪音比较大的公交车,才能顺利的回到自己的单位上班.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pRAbV0.html" rel="bookmark" class="title">jquery appendTo 和 append 的用法</a>
					<div>
						appendTo 会移动元素. 比如: &lt;div class=&quot;wrap&quot;&gt; &lt;div class=&quot;div1&quot;&gt;111&lt;/div ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBRYpZM.html" rel="bookmark" class="title">spring源码&mdash;&mdash;资源的注册及依赖注入</a>
					<div>
						一 注册 注册过程并不复杂,就是把解析得到的beandefinition设置到hashmap中去.需要注意的是,如果遇到同名的beandefinition,需要去判断allowbeandefiniti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YDwlOM.html" rel="bookmark" class="title">从全排列看递归</a>
					<div>
						1.什么是递归 1)举个生活中的例子:假设有一项很繁重的工作,我们总能把它划分为:总工作量=今天的工作+剩下的工作,只要我们每天都在坚持,一点点继续,那么剩下的工作会越来越少,总有一天,我们可以实现我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ekBQb4.html" rel="bookmark" class="title">Sqlserver2000联系Oracle11G数据库进行实时数据的同步</a>
					<div>
						1,前提条件 我有sqlserver2000环境,已经存在oracle11g环境,准备这两个数据库,建立各自的訪问账号,两者之间须要ping通,telnetport也要能通,目的是将sqlserver ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nLdzv4.html" rel="bookmark" class="title">空指针与函数指针</a>
					<div>
						空指针(void pointers) void 指针可以指向任意类型的数据.唯一的限制是被指向的值不能被直接引用(即不可以对它们使用解引符*),因为它的长度是不定的. 因此,必须使用类型转换操作或赋值 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6XnAX3.html" rel="bookmark" class="title">Class&period;isAssignableFrom&lpar;Class clz&rpar;方法 与 instanceof 关键字的区别</a>
					<div>
						Class.isAssignableFrom(Class clz)方法 与 instanceof 关键字的区别 博客分类: Java .netHTML 原地址:http://topic.csdn.ne ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e9ZVZ0.html" rel="bookmark" class="title">代码回忆</a>
					<div>
						1 &lt;!DOCTYPE html PUBLIC &quot;-//W3C//DTD XHTML 1.0 Transitional//EN&quot; &quot;http://www.w3.or ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35p5ZE0.html" rel="bookmark" class="title">WeakHashMap学习（一） &mdash;&mdash; Difference between HashMap and WeakHashMap</a>
					<div>
						WeakHashMap is an implementation of Mapinterface where the memory of the value object can be reclaim ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgmoYn3.html" rel="bookmark" class="title">&lbrack;IOS 开发&rsqb; UIImage改变像素值</a>
					<div>
						- (UIImage*) imageBlackToTransparent:(UIImage*) image { // 分配内存 const int imageWidth = image.size.wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q89QW0.html" rel="bookmark" class="title">scrollBarStyle- listview滑动条调整</a>
					<div>
						今天在解决问题的时候,需要设置listview滚动条,使listview的内容不能被滚动条覆盖 后来发现网上提到一个 ScrollView 属性.ScrollView中ScrollBar的style  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
